<%@page language="java"%>
<%@taglib prefix="logic" uri="/WEB-INF/struts-logic.tld"%>
<%@taglib prefix="bean" uri="/WEB-INF/struts-bean.tld"%>
<%@taglib prefix="html" uri="/WEB-INF/struts-html.tld"%>
<html:xhtml />
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>jython session - <bean:write name="sessionForm" property="name" /></title>
<script type="text/javascript">
function getReq()
{
  var req = null;
try {
  if (window.XMLHttpRequest) {
    req = new XMLHttpRequest();
  } else if (window.ActiveXObject) {
    req = new ActiveXObject("Microsoft.XMLHTTP");
  }
} catch ( e ) { alert(e); }
  return req;
}


function inLineSubmit( sessionName, textAreaId )
{
  var textArea = document.getElementById( textAreaId );
  var pyExpr = textArea.value;
  var formPath = document.getElementById( 'inputForm' ).action;
  var req = getReq();
  if ( req == null )
  {
    // allow original submit in face of error.
    return true;
  }
  req.onreadystatechange = function() {
        if ( req.readyState == 4 )
        {
          var bottomHr = document.getElementById( 'bottom' );
          bottomHr.parentNode.insertBefore( req.responseXML.firstChild, bottomHr );
          textArea.setAttribute( 'value', '' );
          textArea.focus();
        }
      }
  req.open( "POST", formPath, true );
  req.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
  req.send( "dispatch=inlineExpr&pythonExpression=" + encodeURIComponent(pyExpr) );

  return false;
}
</script>
<style type="text/css">
.requestResponse
{
    border: solid thin black;
    margin-bottom: 1em;
    font-family: monospace;
}

.timeStamp
{
  float:right;
  font-size: small;
  color: lightgray;
}

.request
{
  background-color: black;
  color: white;
}

</style>
</head>
<body>
<h1>session: <bean:write name="sessionForm" property="name" /></h1>
<logic:iterate name="sessionForm" property="session.goRounds" id="elt">
<div class="requestResponse">
  <div class="timeStamp"><bean:write name="elt" property="timestamp" /></div>
  <div class="request">&gt;&gt;&gt; <bean:write name="elt" property="request" /></div>
  <div class="response"><bean:write name="elt" property="response" /></div>
</div>
</logic:iterate>

<hr id="bottom" />

<bean:define id="name" name="sessionForm" property="name" />
<html:form action="<%= "/session/" + name + ".action"%>"
           styleId="inputForm"
           onsubmit="<%= "return inLineSubmit( '" + name + "', 'pyExpr')" %>">
<html:hidden property="dispatch" value="expr" />
<html:textarea cols="80" rows="5" property="pythonExpression" styleId="pyExpr" /><br />
<html:submit/>
</html:form>
</body>
</html>
